<?php
	
	OnlyShowIf(CheckAdmin());
	
	require_once($installfolder.'/model/property.php');
	
	$id = 0;
	if (isset($_REQUEST['id'])) 
	{
		$id = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
		if ($id === FALSE) exit;
	}
	
	$propinfo = array();
	if ($id != 0)
	{
		$query = $db->query('SELECT * FROM notifier_notices WHERE id='.$id);
	
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$propinfo = $row;
		}

		$modename = "Update Notice";
		
		if ((isset($_REQUEST['delete'])) || ((isset($_REQUEST['mode'])) && ($_REQUEST['mode'] == 'delete')))
		{
			$modename = "Delete Notice";
			
			if (isset($_POST['confirm']))
			{
				//Delete It!
				$db->query("DELETE FROM notifier_notices WHERE id=".$id);
				//include ('../../include/updaterelcache.php');
				header("Location: ".$sitefolder."/notifier/notification");
				exit;
			}
		}
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			if (!isset($_REQUEST['name'])) exit;
			
			$name = $_REQUEST['name'];
			
			if (trim($name) == "") 
				$errormsg = "You must specify a valid, unique name for your notice.";
			else
			{			
				$query = $db->query('SELECT * FROM notifier_notices WHERE name='.$db->quote($name).' AND id <> '.$id);
									
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$errormsg = "Your notice name is not unique. Please select another name.";
				}
			}
			
			if (!isset($errormsg))
			{
				$db->query("UPDATE notifier_notices SET name=".$db->quote($name)." WHERE id=".$id);
				
				$newid = $id;
				
				//echo 'Updating...';
				foreach($_REQUEST as $k => $v)
				{
					if (strlen($k) > 6)
					{
						$vx = substr($k,0,6);
						if ($vx == "value_")
						{
							$sub = substr($k,6);
							if ($sub[0] == '_')
							{
								$sub = $_REQUEST['lookup_'.substr($sub,1)];
							}
							//echo "INSERT INTO notifier_noticetext (noticeid, value, message) VALUES (".$newid.",".$db->quote($sub).",".$db->quote($v).") ON DUPLICATE KEY UPDATE message=".$db->quote($v);
							$db->query("INSERT INTO notifier_noticetext (noticeid, value, message) VALUES (".$newid.",".$db->quote($sub).",".$db->quote($v).") ON DUPLICATE KEY UPDATE message=".$db->quote($v));
						}
					}
				}
				
				$query = $db->query("SELECT id FROM assets WHERE name='Notification Group'");
	
				$groupid = 0;
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$groupid = $row['id'];
				}
				
				$query = $db->query("SELECT id FROM assets WHERE name='Contact'");
			
				$contactid = 0;
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$contactid = $row['id'];
				}
				
				if ($groupid == 0)
				{
					echo '<tr><td><strong>ERROR</strong>: The notification system requires a tag named \'Notification Group\' that contains your various groups. Without this tag, the notification system can not function.</td></tr>';
				}
				else
				{
					$contacts = array();
					$query = $db->query('SELECT childasset FROM assetrelclosures WHERE parentasset='.$contactid);
					while($row = $query->fetch(PDO::FETCH_ASSOC)) 
					{
						$contacts[] = $row['childasset'];
					}
					
					$matches = array();
					$query = $db->query('SELECT childasset FROM assetrelclosures JOIN assets ON (assetrelclosures.childasset = assets.id) WHERE parentasset='.$groupid.' ORDER BY name');
					//echo 'SELECT childasset, name FROM assetrelclosures JOIN assets ON (assetrelclosures.childasset = assets.id) WHERE parentasset='.$groupid.' ORDER BY name';
				
					while($row = $query->fetch(PDO::FETCH_ASSOC)) 
					{
						if (in_array($row['childasset'],$contacts))
						{
							continue;
						}
						if (isset($_REQUEST['chk_'.$row['childasset']]))
						{
							$matches[] = $row['childasset'];
						};
					}	
				}
				
				foreach($matches as $m)
				{
					$db->query("INSERT INTO notifier_noticegroups (id, groupid) VALUES (".$newid.",".$m.")");
				}
				
				header("Location: ".$siteroot."/notifier/notification");
				exit;
			}
		}

	}
	else
	{		
		
		$propinfo['name'] = '';
		$propinfo['email'] = "";
		$propinfo['mobile'] = "";		
		
		$modename = "Add Notification";

		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			//print_r($_FILES);
			$aid = $_REQUEST['refidnum'];
			$pid = $_REQUEST['refprop'];
			$tg = $_REQUEST['trigger'];
			$expr = "#";
			$name = $_REQUEST['name'];
			
			if ((!isset($errormessage)) || ($errormessage == ""))
			{
				$fieldset = array();
				$content = array();
				
				$db->query("INSERT INTO notifier_notices (name, assetid, propertyid, expr, state) VALUES (".$db->quote($name).",".$aid.",".$pid.",".$db->quote($expr).",0)");
				
				//echo "INSERT INTO notifier_notices (name, assetid, propertyid, expr, state) VALUES (".$db->quote($name).",".$aid.",".$pid.",".$db->quote($expr).",0)";
				
				$newid = $db->lastInsertId();
				if ($newid == 0)
				{
					exit;
				}
				
				//Set per-value message formats...
				foreach($_REQUEST as $k => $v)
				{
					if (strlen($k) > 6)
					{
						$vx = substr($k,0,6);
						if ($vx == "value_")
						{
							$sub = substr($k,6);
							if ($sub[0] == '_')
							{
								$sub = $_REQUEST['lookup_'.substr($sub,1)];
							}
							$db->query("INSERT INTO notifier_noticetext (noticeid, value, message) VALUES (".$newid.",".$db->quote($sub).",".$db->quote($v).")");
						}
					}
				}
				
				$query = $db->query("SELECT id FROM assets WHERE name='Notification Group'");
	
				$groupid = 0;
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$groupid = $row['id'];
				}
				
				$query = $db->query("SELECT id FROM assets WHERE name='Contact'");
			
				$contactid = 0;
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$contactid = $row['id'];
				}
				
				if ($groupid == 0)
				{
					echo '<tr><td><strong>ERROR</strong>: The notification system requires a tag named \'Notification Group\' that contains your various groups. Without this tag, the notification system can not function.</td></tr>';
				}
				else
				{
					$contacts = array();
					$query = $db->query('SELECT childasset FROM assetrelclosures WHERE parentasset='.$contactid);
					while($row = $query->fetch(PDO::FETCH_ASSOC)) 
					{
						$contacts[] = $row['childasset'];
					}
					
					$matches = array();
					$query = $db->query('SELECT childasset FROM assetrelclosures JOIN assets ON (assetrelclosures.childasset = assets.id) WHERE parentasset='.$groupid.' ORDER BY name');
					//echo 'SELECT childasset, name FROM assetrelclosures JOIN assets ON (assetrelclosures.childasset = assets.id) WHERE parentasset='.$groupid.' ORDER BY name';
				
					while($row = $query->fetch(PDO::FETCH_ASSOC)) 
					{
						if (in_array($row['childasset'],$contacts))
						{
							continue;
						}
						if (isset($_REQUEST['chk_'.$row['childasset']]))
						{
							$matches[] = $row['childasset'];
						};
					}	
				}
				
				foreach($matches as $m)
				{
					$db->query("INSERT INTO notifier_noticegroups (id, groupid) VALUES (".$newid.",".$m.")");
				}
				
				header("Location: ".$siteroot."/notifier/notification");
				exit;
			}
		}
	}
	
	if ($modename == "Delete Notice")
	{
		$title = "Delete ".$propinfo['name'];
	
		include($installfolder.'/include/tmpl.php');
		include($installfolder.'/model/property.php');

		T('header-basic','title='.$title);	
		
		ST('section','class=content');
			ST('row');
				ST('half');?>
				    <form method="POST" action="update.php"><?php
					ST('box','title='.$modename);?>
					<a href="" class="btn btn-success" onclick="history.go(-1); return false;">No - Cancel</a>&nbsp;&nbsp;<input type="submit" value="Yes - Delete It" class="btn btn-warning"/><?php
						SS('footer');
						
?>	
    	Are you sure you want to delete your '<?php echo $propinfo['name']?>' notification?<br/>
        <input type="hidden" name="id" value="<?php echo $id;?>"/>
        <input type="hidden" name="delete" value="true"/>
        <input type="hidden" name="confirm" value="true"/>        
<?php 				ET();?>
					</form><?php
				ET();
			ET();
		ET();
		exit;
	};
	
	$title = "Add New Notification";
	
	if ($id != 0) $title = "Update Notification";
	
	include($installfolder.'/include/tmpl.php');

?>
	
var assetlist = new Bloodhound({
  datumTokenizer: Bloodhound.tokenizers.obj.whitespace('text'),
  queryTokenizer: Bloodhound.tokenizers.whitespace,
  remote: '<?php echo $siteroot;?>/ajax/assetnamesearch?q=%QUERY',  
  //local: $.map(assets, function(state) { return { value: state }; })
});
 
// kicks off the loading/processing of `local` and `prefetch`
assetlist.initialize();

$("#lookitup").typeahead({
    	hint: true,
        highlight: true,
        minLength: 2
    },{
	    name: 'assets',
        displayKey: 'text',
        source: assetlist.ttAdapter(),
        templates: {
            empty: [
              '<div class="tt-suggestions" style="font-size: small;"><div class="tt-suggestion">This asset could not be found.</a>',
              '</div>'
            ].join('\n')            
        }        
    });
    
    var nm = $('#lookitup').attr('name');    
    
    $("#lookitup").on('typeahead:selected',function (evt,item) {    	
        $('#refid').val(item.id);
        SelectedAsset();
    });
    
    $("#lookitup").after('<input type="hidden" name="refid" id="refid"/>');

<?php SS('onload'); ?>

<script src="/plugins/typeahead/typeahead.bundle.min.js"></script>
<?php
	SS('addscripts');
?>
<script>
function SelectedAsset()
{
	var value = $('#lookitup').val();
	var id = $('#refid').val();
	
	if (id <= 0) return;
	
	var tg = $('#trigger').val();
	if (tg == 'trip') tg = 'alertlist';
	if (tg == 'change') tg = 'propertylist';
	
	$('#refidnum').val(id);
	
	//OK, update the list...
	//alert('<?php echo $siteroot; ?>/asset/' + tg);
	$.post('<?php echo $siteroot; ?>/asset/' + tg,{ id: id },function(data) {
		$('#refprop').html(data);
		AutoName();
	}).error(function () {
		$('#refprop').html('<option>Error Loading Properties</option>');
	});
}

function RefreshList()
{
	SelectedAsset();
}

function AutoName()
{
	var nm = "When " + $('#lookitup').val() + " " + $('#refprop').children(":selected").text();
	if ($('#trigger').val() == 'change') 
		nm += " changes";
	else
		nm += " is tripped";
		
	$('#name').val(nm);
	
	//Reload message content...
	if ($('#trigger').val() == 'change') 
	{
		$.post('<?php echo $siteroot; ?>/notifier/notification/statemessages',{ asset: $('#refid').val(), property: $('#refprop').children(":selected").val() },function(data) {
			$('#mcontent').html(data);
		}).error(function () {
			$('#mcontent').html('Error Loading Message Content');
		});
	}
	else
	{
		alert('Asset '+ $('#refid').val() + ' / alert ' + $('#refprop').children(":selected").val());
		$.post('<?php echo $siteroot; ?>/notifier/notification/statemessages',{ asset: $('#refid').val(), alert: $('#refprop').children(":selected").val() },function(data) {
			$('#mcontent').html(data);
		}).error(function () {
			$('#mcontent').html('Error Loading Message Content');
		});
	}
}
</script>
<?php
	
	ST('section','class=content');?>
		<form method="POST" action="update" enctype="multipart/form-data"><?php
		ST('row');
			ST('half');?>
				<?php
				ST('box','title='.$modename);?>
				<input type="hidden" name="id" value="<?php echo $id;?>"/>
        
				<br/><input type="submit" class="btn btn-success" value="<?php echo $modename; ?>"/><?php
						SS('footer');
						ST('ftable');
						if ($id == 0) {?>
		<input type="hidden" name="refidnum" id="refidnum"/><!--<tr><td>-->
    	
		<tr><td>
			<label>Notify When:</label></td><td>
			<select name="trigger" id="trigger" onchange="AutoName(); RefreshList();">
				<option value="trip">An Alert is Tripped On...</option>
				<option value="change">A Value Changes On...</option>
			</select>
		</td></tr>
		<tr><td><label>Asset:</label></td><td><input type="text" style="border: 1px solid blue; left: -3px;  border-radius: 3px; margin-left: 0px;" id="lookitup" name="refasset" onchange="AutoName();"/></td></tr>
		<tr><td><label>Alert/Property:</label></td><td><select id="refprop" name="refprop" onchange="AutoName();"><option>Choose An Asset First</option></select></td></tr>
		<?php
		}
		else
		{ ?>
			<tr><td><label>Triggers When:</label></td><td><?php
			if ($propinfo['expr'] == 'A')
			{
				$ast = new Asset($propinfo['assetid']);
				$query = $db->query('SELECT name FROM alerts WHERE id='.$propinfo['propertyid']);
	
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$alert = $row['name'];
				}
				echo 'The &quot;'.$alert.'&quot; alert triggers on '.$ast->name.'.';
			}
			else
			{
				$ast = new Asset($propinfo['assetid']);
				$prx = Properties::GetAllProperties();
				foreach($prx as $p)
				{
					if ($p->id == $propinfo['propertyid'])
					{
						echo 'The '.$p->name.' changes on '.$ast->name;
						break;
					}
				}
			}?>
			</td></tr><?php
		}?>
		<tr><td>
		<label>Name:</label></td><td>
		
		<input type="text" name="name" id="name" style="width: 100%;" value="<?php echo $propinfo['name']; ?>"/></td></tr>
		<tr><td colspan="1">&nbsp;</td></tr>
		<tr><td>
		<label>Time Delay:</label><br/><span style="font-size: small;">0=Immediate</span></td><td>
		<input type="text" name="delay" id="delay" value="<?php echo 0; ?>"/></td></tr>
        <?php 
		
						ET();
					ET();

					
					ST('box','title=Message Content');
						echo '<div id="mcontent">';
						ST('ftable');
							if ($id == 0) {?>
							<tr><td>Please select an trigger, asset and property.</td></tr><?php
							}
							else
							{
								$_REQUEST['asset'] = $propinfo['assetid'];
								if ($propinfo['expr'] == 'A')
								{
									$_REQUEST['alert'] = $propinfo['propertyid'];
								}
								else
								{
									$_REQUEST['property'] = $propinfo['propertyid'];
								}
								$_REQUEST['notice'] = $id;
								include('statemessages.php');
							}?>
							<!--<tr><td><label>When In Alarm:</label></td><td><input style="width: 100%;" type="text" value="Alert: This Alert Has Triggered"/></td></tr>
							<tr><td><label>When Normal:</label></td><td><input style="width: 100%;" type="text" value="Resolved: This Alert Has Triggered"/></td></tr>-->
							<?php
						ET();
						echo '</div>';
					ET();
				ET();
					ST('half');?>
				<?php
				ST('box','title=Contact Groups');        
					ST('ftable');
		
		//OK - first, find a tag in the root of the asset hierarchy called ''
		$query = $db->query("SELECT id FROM assets WHERE name='Notification Group'");
	
		$groupid = 0;
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$groupid = $row['id'];
		}
		
		$query = $db->query("SELECT id FROM assets WHERE name='Contact'");
	
		$contactid = 0;
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$contactid = $row['id'];
		}
		
		if ($groupid == 0)
		{
			echo '<tr><td><strong>ERROR</strong>: The notification system requires a tag named \'Notification Group\' that contains your various groups. Without this tag, the notification system can not function.</td></tr>';
		}
		else
		{
			$contacts = array();
			$query = $db->query('SELECT childasset FROM assetrelclosures WHERE parentasset='.$contactid);
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$contacts[] = $row['childasset'];
			}
			
			$query = $db->query('SELECT childasset, name FROM assetrelclosures JOIN assets ON (assetrelclosures.childasset = assets.id) WHERE parentasset='.$groupid.' ORDER BY name');
			//echo 'SELECT childasset, name FROM assetrelclosures JOIN assets ON (assetrelclosures.childasset = assets.id) WHERE parentasset='.$groupid.' ORDER BY name';
		
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				if (in_array($row['childasset'],$contacts))
				{
					continue;
				}?>
				<tr><td><input type="checkbox" name="chk_<?php echo $row['childasset'];?>"/>&nbsp;&nbsp;<?php echo $row['name'];?>
				</td></tr><?php
			}	
		}
						ET();
					ET();
					
				ET();
		ET();
		 ?>
    </form>
 <?php
	ET();?>