<?php

OnlyShowIf(CheckAdmin());

$pagesize = 10;
$pagestart = 0;

$title = "Contact List";

include($installfolder.'/include/tmpl.php');
//include($installfolder.'/model/model.php');

global $db;

$itemcount = 0;

$pagenum = 1;
if (isset($_REQUEST['page']))
{
	$pagenum = $_REQUEST['page'];
}

$pagestart = ($pagenum-1)*$pagesize;
$totalpages = ceil($itemcount / $pagesize);

$contacttag = 0;

//Locate the 'contact' tag....
$query = $db->query("SELECT id FROM assets WHERE name='Contact' AND type=1");
if($row = $query->fetch(PDO::FETCH_ASSOC)) 
{
	$contacttag = $row['id'];
}

$orgroot = 0;

//Locate the 'contact' tag....
$query = $db->query("SELECT rootasset FROM relationships WHERE name='Organisation'");
if($row = $query->fetch(PDO::FETCH_ASSOC)) 
{
	$orgroot = $row['rootasset'];
}

T('header-basic','title='.$title);

ST('section','class=content');
	ST('row');
		
		ST('half');
			ST('box-collapsible','title=Contact List');
/*				ST('row');
-					ST('half');?>
				<a href="<?php echo $siteroot; ?>/notifier/contacts/update?mode=add" class="btn btn-success">Add New Contact</a><?php
					ET();
					ST('half'); */?>
					To add contacts, add new assets ( perhaps under the <a href="<?php echo $siteroot;?>/diagram/<?php echo $orgroot;?>/3">Organisation</a> hierarchy ) and tag them with the <a href="<?php echo $siteroot;?>/diagram/<?php echo $contacttag;?>/3">Contact</a> tag.<br/><br/>Remember to set their contact details.
				<div class="datatables_paginate paging_simple_numbers" style="text-align: right; margin-top: 0px;">
					<ul class="pagination" style="margin-top: 0px";>
					<?php if ($pagestart > 0) { ?>
						<li class="paginate_button previous"><a href="<?php echo $siteroot; ?>/admin/models/index?page=<?php echo $pagenum-1;?>">Previous</a></li><?php }; 
						$pbase = $pagenum - 3;
						if ($pbase < 1) $pbase = 1;
						for($x=$pbase;$x<$pbase+7;$x++)
						{
							if ($x > $totalpages) break;?>
							<li class="paginate_button<?php if ($x == $pagenum) echo ' active';?>"><a href="<?php echo $siteroot; ?>/notifier/contacts/index?page=<?php echo $x;?>"><?php echo $x; ?></a></li><?php 
						};
						if ($pagenum < $totalpages)
						{?>
						<li class="paginate_button next"><a href="<?php echo $siteroot; ?>/notifier/contacts/index?page=<?php echo $pagenum+1;?>">Next</a></li><?php }; ?>
					</ul>
				</div><?php
//					ET();
//				ET();
				SS('footer');
				
				ST('table');
					$query = $db->query('SELECT name,id FROM assets JOIN assetrelclosures ON (childasset=assets.id) WHERE parentasset='.$contacttag.' ORDER BY name ASC LIMIT '.$pagestart.','.$pagesize);
					//echo 'SELECT name,id FROM notify_contacts ORDER BY name ASC LIMIT '.$pagestart.','.$pagesize;
					while($row = $query->fetch(PDO::FETCH_ASSOC)) 
					{
						$name = $row['name']; ?>
						<tr><td><a href="<?php echo $siteroot.'/dashboard/'.$row['id'];?>"><?php echo $row['name'];?></a></td></tr>
						<?php
					}
				ET();
			ET();
		ET();
	ET();	
ET();

?>
