<?php

	$assetid = $_REQUEST['asset'];
	if (isset($_REQUEST['property']))
	{
		$propertyid = $_REQUEST['property'];
	}
	if (isset($_REQUEST['alert']))
	{
		$alertid = $_REQUEST['alert'];
	}
	$notice = 0;
	if (isset($_REQUEST['notice']))
	{
		$notice = $_REQUEST['notice'];
	}
	
	$existing = array();
	if ($notice != 0)
	{
		$query = $db->query('SELECT value,message FROM notifier_noticetext WHERE noticeid='.$notice);
		
		while($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$existing[] = $row;
		}
	}
	
	//print_r($existing);
	
	$ass = new Asset($assetid);
	
	function CheckDynamics($aid, $value, $name,$existing)
	{
		//OK - before we finalise this, let's take a quick look at any bindings and transforms this has...
		if (isset($value->value['_dynamics']))
		{
			//OK - load the transforms present on this link...
			global $db;
			
			$query = $db->query('SELECT transform FROM datalinks WHERE assetid='.$aid.' AND mode=0 AND profile=1 AND propertyid='.$value->id);
	
			while($row = $query->fetch(PDO::FETCH_ASSOC)) 
			{
				$tx = $row['transform'];
			}
			
			if (isset($tx))
			{
				if ($tx != "")
				{
					$parts = explode('^',$tx);
					foreach($parts as $p)
					{
						$bits = explode('|',$p);
						if ($bits[0] == 'MATCH')
						{
							for($x=1;$x<count($bits);$x+=2)
							{
								$vv = GetMessageFor($bits[$x+1],$existing,$name.' is now '.$bits[$x+1]); ?>
								<tr><td style="width: 25%;"><label><?php echo $bits[$x+1];?>:&nbsp;&nbsp;&nbsp;</label></td><td><input name="value__<?php echo $bits[$x];?>" style="width:100%; margin-bottom: 0.5em;" value="<?php echo $vv;?>"/>
								<input type="hidden" name="lookup_<?php echo $bits[$x];?>" value="<?php echo $bits[$x+1];?>"/></td></tr><?php
							}
							return true;
						}
					}
				}
			}
			
			return false;
		}
	}
	
	function GetMessageFor($lookup, $existing, $default)
	{
		foreach($existing as $ex)
		{
			if ($ex['value'] == $lookup)
			{
				return $ex['message'];
			}
		}
		return $default;
	}
	
	echo '<table style="width: 100%;">';
	if (isset($propertyid))
	{
		$props = $ass->GetProperties();
		$ass->GetValues($props);
		
		foreach($props as $p)
		{
			if ($p->id == $propertyid)
			{
				$name = $ass->name.' '.$p->name;
				if ($p->type == 'MEASUREMENT')
				{
					$vv = $ass->name.' '.$p->name.' is now [VALUE]'.$p->value['units'];
					$vv = GetMessageFor('*',$existing,$vv);
					if (!CheckDynamics($assetid,$p,$name,$existing)) { ?>
					<tr><td style="width: 25%;"><label>When the value changes:&nbsp;&nbsp;&nbsp;</td><td><input type="text" name="value_*" style="width: 100%;" value="<?php echo $vv; ?>"/></td></tr><?php
					}					
				}
				if ($p->type == 'STATE')
				{
					$vv = $ass->name.' '.$p->name.' is now [VALUE]';
					$vv = GetMessageFor('*',$existing,$vv);
					if (!CheckDynamics($assetid,$p,$name,$existing)) {
					?>
					<tr><td style="width: 25%;"><label>When the value changes:&nbsp;&nbsp;&nbsp;</td><td><input type="text" name="value_*" style="width: 100%;" value="<?php echo $vv; ?>"/></td></tr><?php
					};
				}
				if ($p->type == 'STATUS')
				{
					$vx = $ass->name.' '.$p->name;
					$vv = GetMessageFor('1',$existing,$vx.' is '.$p->value['on']);?>
					<tr><td style="width: 25%;"><label>When <?php echo $p->values['on'];?>:&nbsp;&nbsp;&nbsp; </td><td><input type="text" name="value_1" style="width: 100%;" value="<?php echo $vv; ?>"/></td></tr>
					<?php $vv = GetMessageFor('0',$existing,$vx.' is '.$p->value['off']);?>
					<tr><td><label>When <?php echo $p->values['off'];?>:&nbsp;&nbsp;&nbsp; </td><td><input type="text" name="value_0" style="width: 100%; margin-bottom: 0.5em;" value="<?php echo $vv; ?>"/></td></tr><?php
				}
			}
		}
	}
	if ((isset($alertid)) && ($alertid != 0))
	{
		
		$alert = array();
		$query = $db->query('SELECT * FROM alerts WHERE id='.$alertid);
	
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$alert = $row;
		}
	
		$vn = $ass->name.' '.$alert['name'];
		$vv = GetMessageFor('1',$existing,'ALERT: '.$vn);?>
		<tr><td><label>When Active: &nbsp;&nbsp;&nbsp;</td><td><input type="text" name="value_1" style="width: 100%; margin-bottom: 0.5em;" value="<?php echo $vv; ?>"/></td></tr>
		<?php $vv = GetMessageFor('0',$existing,'RESOLVED: '.$vn); ?>
		<tr><td><label>When Inactive: &nbsp;&nbsp;&nbsp;</td><td><input type="text" name="value_0" style="width: 100%;" value="<?php echo $vv; ?>"/></td></tr><?php
	}
	echo '</table>';

?>