<?php
	
	OnlyShowIf(CheckAdmin());
	
	$id = 0;
	if (isset($_REQUEST['id'])) 
	{
		$id = filter_var($_REQUEST['id'],FILTER_VALIDATE_INT);
		if ($id === FALSE) exit;
	}
	
	$propinfo = array();
	if ($id != 0)
	{
		$query = $db->query('SELECT * FROM notifier_contacts WHERE id='.$id);
	
		if($row = $query->fetch(PDO::FETCH_ASSOC)) 
		{
			$propinfo = $row;
		}

		$modename = "Update Contact";
		
		if ((isset($_REQUEST['delete'])) || ((isset($_REQUEST['mode'])) && ($_REQUEST['mode'] == 'delete')))
		{
			$modename = "Delete Contact";
			
			if (isset($_POST['confirm']))
			{
				//Delete It!
				$db->query("DELETE FROM notifier_contacts WHERE id=".$id);
				//include ('../../include/updaterelcache.php');
				header("Location: ".$sitefolder."/notifier/contacts");
				exit;
			}
		}
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			if (!isset($_REQUEST['name'])) exit;
			
			$name = $_REQUEST['name'];
			
			if (trim($name) == "") 
				$errormsg = "You must specify a valid, unique name for your relationship.";
			else
			{			
				$query = $db->query('SELECT * FROM notifier_contacts WHERE name='.$db->quote($name).' AND id <> '.$id);
									
				if($row = $query->fetch(PDO::FETCH_ASSOC)) 
				{
					$errormsg = "Your contact name is not unique. Please select another name.";
				}
			}
			
			if (!isset($errormsg))
			{
				$db->query("UPDATE notifier_contacts SET name=".$db->quote($name)." WHERE id=".$id);
				
				foreach($content as $k=>$v)
				{
					$db->query("INSERT INTO notifier_contactdetails (id,name,value) VALUES (".$k.",".$db->quote($k).",".$db->quote($v).") ON DUPLICATE KEY UPDATE value=".$db->quote($v));
				}
				//include ('../../include/updaterelcache.php');
				header("Location: index.php");
				exit;
			}
		}

	}
	else
	{		
		
		$propinfo['name'] = '';
		$propinfo['email'] = "";
		$propinfo['mobile'] = "";		
		
		$modename = "Add Contact";
		
		if ($_SERVER['REQUEST_METHOD'] == 'POST')
		{
			//print_r($_FILES);
			
			if ((!isset($errormessage)) || ($errormessage == ""))
			{
				$fieldset = array();
				$content = array();
				
				$attrs = array();
				$files = glob($installfolder + "/addons/notifier/methods/*.inc");
				foreach($files as $fl)
				{
					include ($fl);
					foreach($fields as $f)
					{
						$attrs[$f['name']] = $f['title'];
					}
				}
				
				foreach($attrs as $k => $v)
				{
					if (isset($_REQUEST[$k]))
					{
						$content[$k] = $db->quote($_REQUEST[$k]);
					}
				}
				
				$db->query("INSERT INTO notifier_contacts (name) VALUES (".$db->quote($name).")");
				
				$newid = $db->lastInsertId();
				foreach($content as $k=>$v)
				{
					$db->query("INSERT INTO notifier_contactdetails (id,name,value) VALUES (".$k.",".$db->quote($k).",".$db->quote($v).")");
				}
				
				//include ('../../include/updaterelcache.php');
				header("Location: index.php");
				exit;
			}
		}
	}
	
	if ($modename == "Delete Contact")
	{
		$title = "Delete ".$propinfo['name'];
	
		include($installfolder.'/include/tmpl.php');
		include($installfolder.'/model/property.php');

		T('header-basic','title='.$title);	
		
		ST('section','class=content');
			ST('row');
				ST('half');?>
				    <form method="POST" action="update.php"><?php
					ST('box','title='.$modename);?>
					<a href="" class="btn btn-success" onclick="history.go(-1); return false;">No - Cancel</a>&nbsp;&nbsp;<input type="submit" value="Yes - Delete It" class="btn btn-warning"/><?php
						SS('footer');
						
?>	
    	Are you sure you want to delete your contact '<?php echo $propinfo['name']?>'?<br/>
        <input type="hidden" name="id" value="<?php echo $id;?>"/>
        <input type="hidden" name="delete" value="true"/>
        <input type="hidden" name="confirm" value="true"/>        
<?php 				ET();?>
					</form><?php
				ET();
			ET();
		ET();
		exit;
	};
	
	$title = "Add New Contact";
	
	include($installfolder.'/include/tmpl.php');


	ST('section','class=content');?>
		<form method="POST" action="update" enctype="multipart/form-data"><?php
		ST('row');
			ST('half');?>
				<?php
				ST('box','title='.$modename);?>
				<input type="hidden" name="id" value="<?php echo $id;?>"/>
        
				<br/><input type="submit" class="btn btn-success" value="<?php echo $modename; ?>"/><?php
					SS('footer');
						SS('ftable');?><tr><td>
    	<label>Name:</label></td><td>
		<input type="text" name="name" value="<?php echo $propinfo['name']; ?>"/></td></tr>
		<?php
		$attrs = array();
		$files = glob($installfolder + "/addons/notifier/methods/*.inc");
		foreach($files as $fl)
		{
			include ($fl);
			foreach($fields as $f)
			{
				$attrs[$f['name']] = $f['title'];
			}
		}
		
		foreach($attrs as $k => $v)
		{?>
		<tr><td>
    	<label><?php echo $v;?>:</label></td><td>
		<input type="text" name="<?php echo $k; ?>" value="<?php echo $propinfo[$k]; ?>"/></td></tr><?php
		}
		?>
		<!--<tr><td>
    	<label>Email Address:</label></td><td>
		<input type="text" name="mail" value="<?php echo $propinfo['mail']; ?>"/></td></tr>
		<tr><td>
    	<label>Mobile Number:</label></td><td>
		<input type="text" name="mobile" value="<?php echo $propinfo['mobile']; ?>"/></td></tr>-->
        <?php
						ET();
					ET();
				ET();
			ET();
		ET();
		 ?>
    </form>
 <?php
	ET();?>