<?php

OnlyShowIf(CheckAdmin());

$pagesize = 10;
$pagestart = 0;

$title = "Notification Administration";

include($installfolder.'/include/tmpl.php');
//include($installfolder.'/model/model.php');

global $db;

$itemcount = 0;

$query = $db->query('SELECT COUNT(*) as Cnt FROM notifier_notices');
while($row = $query->fetch(PDO::FETCH_ASSOC)) 
{
	$itemcount = $row['Cnt'];
}

$pagenum = 1;
if (isset($_REQUEST['page']))
{
	$pagenum = $_REQUEST['page'];
}

$pagestart = ($pagenum-1)*$pagesize;
$totalpages = ceil($itemcount / $pagesize);

T('header-basic','title='.$title);

ST('section','class=content');
	ST('row');
		
		ST('full');
			ST('box-collapsible','title=Notification List');
				ST('row');
					ST('half');?>
				<a href="<?php echo $siteroot; ?>/notifier/notification/update?mode=add" class="btn btn-success">Add New Notification</a><?php
					ET();
					ST('half');?>
				<div class="datatables_paginate paging_simple_numbers" style="text-align: right; margin-top: 0px;">
					<ul class="pagination" style="margin-top: 0px";>
					<?php if ($pagestart > 0) { ?>
						<li class="paginate_button previous"><a href="<?php echo $siteroot; ?>/notifier/notification/index?page=<?php echo $pagenum-1;?>">Previous</a></li><?php }; 
						$pbase = $pagenum - 3;
						if ($pbase < 1) $pbase = 1;
						for($x=$pbase;$x<$pbase+7;$x++)
						{
							if ($x > $totalpages) break;?>
							<li class="paginate_button<?php if ($x == $pagenum) echo ' active';?>"><a href="<?php echo $siteroot; ?>/notifier/notification/index?page=<?php echo $x;?>"><?php echo $x; ?></a></li><?php 
						};
						if ($pagenum < $totalpages)
						{?>
						<li class="paginate_button next"><a href="<?php echo $siteroot; ?>/notifier/notification/index?page=<?php echo $pagenum+1;?>">Next</a></li><?php }; ?>
					</ul>
				</div><?php
					ET();
				ET();
				SS('footer');
				ST('table');
					$query = $db->query('SELECT name,notifier_notices.id FROM notifier_notices ORDER BY name,id ASC LIMIT '.$pagestart.','.$pagesize);

						
					while($row = $query->fetch(PDO::FETCH_ASSOC)) 
					{
						$name = $row['name']; ?>
						<tr><td><a href="<?php echo $siteroot; ?>/notifier/notification/update?id=<?php echo $row['id'];?>"><?php echo $name; ?></a></td>
						<!--<td><a title="Upgrade Contact" href="<?php echo $siteroot;?>/admin/models/update?mode=update&id=<?php echo $row['id'];?>" style="border: none;"><i class="fa fa-trash-o"></i></a>-->
						<td><a title="Remove Notification" href="<?php echo $siteroot;?>/notifier/notification/update?mode=delete&id=<?php echo $row['id'];?>" style="border: none;"><i class="fa fa-trash-o"></i></a>
						</td></tr><?php
					}
				ET();
			ET();
		ET();
	ET();	
ET();

?>
